/* 
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

var teaserWasDisplayed = false; // ティザーを表示したかのフラグ 

function hideLoading()
{
    var krpano = document.getElementById("krpanoSWFObject");
    
    if (teaserWasDisplayed == false) {
        teaserWasDisplayed = true;
      
        // ローディング表示消す (背景レイヤは残す）
        krpano.call("action(hide_loading_for_opening);");
        // ティザー表示
        krpano.call("action(opening);");           
    }
    else {
        // ローディング表示消す
        krpano.call("action(hide_loading);");        
    }
}

// 商品画面データセット&表示
function showItemInfo(title, brand, price, description, linkurl, imageurl, imgWidth, imgHeight)
{  
    var krpano = document.getElementById("krpanoSWFObject");
    
    var title_tag = "<p>" + title + "</p>";
    var brand_tag = "<p>" + brand + "</p>";
    var price_tag = "<p></p>";
    if (price != "") {
//        price_tag = "<p>" + "￥ " + price + "</p>";
        price_tag = "<p>" + "￥ " + currency_format(price) + "</p>";
    }
    var description_tag = "<p>" + description + "</p>";
    var image_tag = "<p><img src='" + imageurl + "' width='" + imgWidth + "' height='" + imgHeight + "'/></p>";
        
    // 新しいデータをセット
    krpano.call("set(data[htmldata_title].content, '" + title_tag + "');");  
    krpano.call("set(data[htmldata_brand].content, '" + brand_tag + "');"); 
    krpano.call("set(data[htmldata_price].content, '" + price_tag + "');"); 
    krpano.call("set(data[htmldata_description].content, '" + description_tag + "');");
    krpano.call("set(data[htmldata_image].content, '" + image_tag + "');");
    krpano.call("set(imageURL, '" + imageurl + "');"); // no-image画像かどうかの判定用
    krpano.call("set(linkURL, '" + linkurl + "');"); 

    // データをプラグインに反映させる
    krpano.call("set(plugin[item_textPrice].html, 'data:htmldata_price')");
    krpano.call("set(plugin[item_textTitle].html, 'data:htmldata_title')");
    krpano.call("set(plugin[item_textBrand].html, 'data:htmldata_brand')");
    krpano.call("set(plugin[item_textDescription].html, 'data:htmldata_description')");
    krpano.call("set(plugin[item_textImage].html, 'data:htmldata_image')");
        
    // 画面開く
    krpano.call("action(open_itemInfoWindow);");
}

function currency_format(price)
{
    // 画面項目の値
    var str= price;
    var num = new String(str).replace(/,/g/"");
    while(num != (num =num.replace(/^(-?\d+)(\d{3})/,"$1,$2")));
    return num;
}

$(function(){
    // ニュース取得
    getNews();
    timer_tick(); // ポーリングスタート 
    timer_newsscroll(); // ニューススクロール用ポーリングスタート
});
               
// ニュース
//var shopId = "029792c1-23ef-4467-9cca-33403ab46371"; // ショップID (DEBUG用!!)
//var shopId = "01f53929-7697-4a9d-807b-f5dab0365c75"; // ショップID (DEBUG用2!!)
var timerInterval = 30; // 30秒間隔 
var numOfNews = 0; // 取得したニュースの数
var items = new Array(); // 取得ニュースを保持
var newsNo = 0; // ニュース番号
var scrollOn = false; // スクロールさせるか
var scrollCnt = 0; // スクロールカウンタ

function timer_tick(){       
    setTimeout(function() {
        updateNews();
        timer_tick();
    }, timerInterval * 1000);
}

function timer_newsscroll(){       
    setTimeout(function() {
        scrollNews();
        timer_newsscroll();
    }, 500);
}

function getNews()
{
    var url = "http://cloud.panoplaza.com/NewsFeeds.aspx?shopid=" + encodeURIComponent(shopId);
                
    $.ajax({
        url: url,
        dataType: 'jsonp',
        success: function (data) {
//            console.log("num of News=" + data.items.length);
                        
            numOfNews = data.items.length;
            items.length = 0; // 配列リセット
            for (var i = 0; i < data.items.length; i++) {
                items[i] = data.items[i];      
            }                     
        }
    });                            
}
            
function updateNews()
{
    var krpano = document.getElementById("krpanoSWFObject");
    if (numOfNews > 0) {
        newsNo = Math.floor(Math.random() * numOfNews);   
        scrollCnt = 0; // スクロールカウンタリセット
        
//        console.log(items[newsNo].description);

        var news_tag = "<p>";
        if (items[newsNo].description != null) {
            news_tag += items[newsNo].description ;
        }
        news_tag += "</p>";
        
        // 新しいデータをセット
        krpano.call("set(data[htmldata_news].content, '" + news_tag + "');");  

        // データをプラグインに反映させる
//        krpano.call("set(plugin[newsBar_content].html, 'data:htmldata_news')");
        krpano.call("action(newsBar_refreshContent);"); // フェードイン表示をする場合
    } else {
        // ニュースが取得できなかった場合、
        var news_tag = "<p>ニュースを取得できませんでした</p>";

        if (krpano != null && scrollOn == false) {
            // 新しいデータをセット
            krpano.call("set(data[htmldata_news].content, '" + news_tag + "');");  

            // データをプラグインに反映させる
            krpano.call("set(plugin[newsBar_content].html, 'data:htmldata_news')");            
        }
    }
}

function scrollNews()
{ 
    if (numOfNews > 0 && scrollOn == true && items[newsNo].description != null) {
        var krpano = document.getElementById("krpanoSWFObject");
        var news_body = items[newsNo].description;
//        var news_body = "ニュースを取得できませんでした"; // DEBUG用
        
        ++scrollCnt;
        var pos = 0;
        var holdtime = 10;
        if (scrollCnt - holdtime < 0) {
            pos = 0; 
        } else if (scrollCnt - holdtime > news_body.length) {
            scrollCnt = 0;
            pos = 0;
        } else {
            pos = scrollCnt - holdtime;
        }
        
        news_body = news_body.slice(pos);
        
//        console.log("scrollCnt=" + scrollCnt + " pos=" + pos);
//        console.log("news_body=" + news_body);
        
        var news_tag = "<p>" + news_body + "</p>";
        
        // 新しいデータをセット
        krpano.call("set(data[htmldata_news].content, '" + news_tag + "');");  

        // データをプラグインに反映させる
        krpano.call("set(plugin[newsBar_content].html, 'data:htmldata_news')");
    }
}

function newsScrollStart()
{
    scrollOn = true;
}

function newsScrollStop()
{
    scrollOn = false;
}

// ブランド情報読み込み
function loadBrandLists()
{
    var nColumnsInRow = 11; // 1列の行数
    var cnt = 0;
    var html = "";
    
    var branddata = "../../pvs/customize/isetan/brands.sample.json";
    
    $.getJSON(branddata, function(data){
        html = "<p>";
        for (var i = 0; i < data.lists.length; i++) {  
            if (data.lists[i] == null) { // IE対策：なぜかlengthが1個多い
                continue;
            }
            var page = data.lists[i].page; 
            cnt = 0; // カウンタリセット
            for (var j = 0; j < data.lists[i].brands.length; j++) {
                //console.log("name=" + data.lists[i].brands[j].name);
                //console.log("url=" + data.lists[i].brands[j].url);  
                
                if (data.lists[i].brands[j] == null) { // IE対策：なぜかlengthが1個多い
                    continue;
                }
//                html += "<a href='event:js(showBrand(" + data.lists[i].brands[j].url + ";)'>" + data.lists[i].brands[j].name + "</a><br/><br/>";
                html += data.lists[i].brands[j].name + "<br/><br/>"; // リンク先をつけない
                ++cnt;
                
                if (cnt % nColumnsInRow == 0) {
                    html += "</p>";                   
//                    console.log("html=", html);
                    setBrandData(page, Math.floor(cnt / nColumnsInRow), html);
                    html = "<p>";
                }
            }
            
            if (cnt % nColumnsInRow != 0) {
                html += "</p>";
//                console.log("html=", html);  
                setBrandData(page, Math.floor(cnt / nColumnsInRow) + 1, html);              
            }
        }        
    });
}

function setBrandData(page, column, html)
{
    var krpano = document.getElementById("krpanoSWFObject");    
    var command = "set(data[htmldata_brandlist_p" + page + "c" + column + "].content, \"" + html + "\");";
//    console.log(command);
    krpano.call(command);  
}

// ブランドの地点へ飛ぶ
function showBrand(url)
{
    // urlのパース   
    
    var paramstr = url.substring(url.indexOf("?") + 1);
        
    // URLの?以下を取得して連想配列に入れる
    var arg = new Object();
    var pair= paramstr.split('&');
    for(i = 0; pair[i]; i++) {
        var kv = pair[i].split('=');
        arg[kv[0]] = kv[1];
    }

    var panoid = arg['panoId'];
    var x = arg['x'];
    var y = arg['y'];
   
//    console.log("panoId=" + panoid);
//    console.log("x=" + x);
//    console.log("y=" + y);
    
    if (panoid == null || x == null || y == null) {
        return;
    }
    
    // 視点移動関数呼ぶ
    var krpano = document.getElementById("krpanoSWFObject");
    krpano.call("jumpto(" + panoid + "," + x + "," +  y + ");");
}

function setPanoramaId(panoramaId)
{
    panoId = panoramaId;
}